#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

int MAX_V = (int) 1e6;

bool isPrime(int n) {
	for (int i = 2; i * i <= n; i++)
		if (n % i == 0) return false;
	return n > 1;
}


int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);
	int n = atoi(argv[1]);
	int m = atoi(argv[2]);
	int k = atoi(argv[3]);
	int rx = atoi(argv[4]);
	int ry = atoi(argv[5]);
	vector<int> primes;
	vector<int> notprimes;
	while (primes.size() < n * m) {
		int cur = rnd.next(1, MAX_V);
		int cnt = 0;
		while (cur <= MAX_V && cnt <= m) {
			if (isPrime(cur)) {
				primes.push_back(cur);
				cnt++;
			}
			cur++;
		}
	}
	while (notprimes.size() < n * m) {
		int cur = rnd.next(1, MAX_V);
		int cnt = 0;
		while (cur <= MAX_V && cnt <= m) {
			if (!isPrime(cur)) {
				notprimes.push_back(cur);
			} else {
				notprimes.push_back(rnd.next(0, 1) ? 1 : MAX_V);
			}
			cnt++;
			cur++;
		}
	}

	vector<vector<int>> a(n, vector<int>(m));
	shuffle(primes.begin(), primes.end());
	shuffle(notprimes.begin(), notprimes.end());
	int cur = 0;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			a[i][j] = notprimes[cur++];	
		}
	}

	int x1 = rnd.next(0, n - 1 - rx);
	int y1 = rnd.next(0, m - 1 - ry);
	int x2 = min(n - 1, x1 + rx - 1);
	int y2 = min(m - 1, y1 + ry - 1);

	cur = 0;

	for (int x = x1; x <= x2; x++) {
		for (int y = y1; y <= y2; y++) {
			a[x][y] = primes[cur++];	
		}
	}

	for (int i = 0; i < k; i++) {
		a[rnd.next(0, n - 1)][rnd.next(0, m - 1)] = primes[rnd.next(0, (int)primes.size() - 1)];
	}



	cout << n << " " << m << endl;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cout << a[i][j] << " \n"[j == m - 1];
		}
	}
}
