def IsPrime(n):
	if n == 1:
		return False
	if n % 2 == 0:
		return n == 2
	d = 3
	while d * d <= n and n % d != 0:
		d += 2
	return d * d > n

n, m = map(int, input().split()) 
a = [[int(j) for j in input().split()] for i in range(n)]
su = [[0] * (m + 1) for i in range(n + 1)]

for i in range(0, n):
	for j in range(0, m):
		su[i + 1][j + 1] = su[i + 1][j] + su[i][j + 1] - su[i][j] + IsPrime(a[i][j]);

ans = 0
for x1 in range(0, n):
	for y1 in range(0, m):
		for x2 in range(x1, n):
			for y2 in range(m - 1, y1, -1):
				sq = (x2 - x1 + 1) * (y2 - y1 + 1)
				if sq < ans:
					break
				if (sq == (su[x2 + 1][y2 + 1] + su[x1][y1] - su[x2 + 1][y1] - su[x1][y2 + 1])):
					ans = max(ans, sq)		

print(ans)
