blocks = int(input())
boys = int(input())
girls = int(input())

if boys + girls == blocks * 5 and (girls == 1 or boys == 1):
    print("No")
    exit(0)

remainGirls = girls % 5
remainBoys = boys % 5
swapped = False
if remainBoys > remainGirls:
    boys, girls = girls, boys
    remainBoys, remainGirls = remainGirls, remainBoys
    swapped = True

room = 0
lastRoomCount = 0


def updateRoom():
    global room
    global lastRoomCount
    lastRoomCount += 1
    if (room % 2 == 0 and lastRoomCount == 3) or \
            (room % 2 == 1 and lastRoomCount == 2):
        room += 1
        lastRoomCount = 0


remainBlocks = blocks - girls // 5 - boys // 5
conflict = remainBoys == 1 and remainGirls == 4 and remainBlocks == 1

boysPlaces = [0] * boys
girlsPlaces = [0] * girls
remainGirls = remainGirls if conflict else 0
remainBoys = remainBoys + 2 if conflict else 0
for i in range(remainGirls, girls):
    girlsPlaces[i] = room + 1
    updateRoom()
if lastRoomCount != 0:
    room += 1
    lastRoomCount = 0
for i in range(remainBoys, boys):
    boysPlaces[i] = room + 1
    updateRoom()

if conflict:
    girlRoom1 = blocks * 2
    girlRoom2 = blocks * 2 - 2
    boyRoom = blocks * 2 - 1
    boysPlaces[0] = boyRoom
    boysPlaces[1] = boyRoom
    boysPlaces[2] = boyRoom
    girlsPlaces[0] = girlRoom1
    girlsPlaces[1] = girlRoom1
    girlsPlaces[2] = girlRoom2
    girlsPlaces[3] = girlRoom2

if swapped:
    boysPlaces, girlsPlaces = girlsPlaces, boysPlaces

print("Yes")
print(*boysPlaces)
print(*girlsPlaces)
