#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

int n, k;

int rsp(char a, char b)
{
	if (a == b)	quitf(_fail, "a == b");
	if (a == 'R' && b == 'P') return -1;
	if (a == 'R' && b == 'S') return 1;
	if (a == 'P' && b == 'R') return 1;
	if (a == 'P' && b == 'S') return -1;
	if (a == 'S' && b == 'P') return 1;
	if (a == 'S' && b == 'R') return -1;
	quitf(_fail, "???");
}

int play(string& a, string& b)
{
//	cerr << a << " " << b << endl;
	for (int i = 0; i < a.length() * b.length(); i++)
	{
//		cerr << "*" << i << endl;
		if (a[i % a.length()] != b[i % b.length()])
		{
//			cerr << rsp(a[i % a.length()], b[i % b.length()]) << endl; 
			return rsp(a[i % a.length()], b[i % b.length()]);
		}
	}
//	cerr << "0";
	return 0;
}

int main(int argc, char* argv[]) {
    registerTestlibCmd(argc, argv);
    
    n = inf.readInt();
	vector<string> prog(n);
	for (int i = 0; i < n; i++)
	{
		prog[i] = inf.readToken();
	}

	string s = ouf.readLine(); 
	string a = ans.readLine(); 
	if (s == "IMPOSSIBLE" && a == "IMPOSSIBLE")
	{
		quitf(_ok, "Impossible");
	}
	
	if (s == "IMPOSSIBLE")
	{
		quitf(_wa, "he did not find an answer");
	}
	
	if (s.length() > 500) quitf(_wa, "line is too long");
	if (s.length() < 1) quitf(_wa, "line is too short");
	
	for (char c : s)
	{
		if (c != 'R' && c != 'S' && c != 'P') quitf(_wa, "incorrect symbol");
	}
    
	for (int i = 0; i < n; i++)
	{
		string& p = prog[i];
		if (play(s, p) != 1) {
			quitf(_wa, "lose to player %d", i + 1);
		}
	}
	
	if (a == "IMPOSSIBLE") quitf(_fail, "impossible, but participant found");
	
    quitf(_ok, "");
}